=== modified file 'NEWS'
--- NEWS	2007-12-19 23:40:39 +0000
+++ NEWS	2007-12-20 00:15:34 +0000
@@ -40,6 +40,9 @@
 
    * ``-l`` is now a short form for ``--limit`` in ``log``.  (Matt Nordhoff)
 
+   * ``merge`` now warns when merge directives cause cherrypicks.
+     (Aaron Bentley)
+
    * ``split`` now supported, to enable splitting large trees into smaller
      pieces.  (Aaron Bentley)
 

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2007-12-06 17:52:30 +0000
+++ bzrlib/merge.py	2007-12-15 04:44:54 +0000
@@ -119,6 +119,8 @@
             tree.branch.repository.get_graph().is_ancestor(
             base_revision_id, tree.branch.last_revision())):
             base_revision_id = None
+        else:
+            warning('Performing cherrypick')
         merger = klass.from_revision_ids(pb, tree, other_revision_id,
                                          base_revision_id)
         return merger, verified

=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2007-12-04 03:13:51 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2007-12-15 04:44:54 +0000
@@ -301,9 +301,10 @@
         target.commit('empty commit')
         self.write_directive('directive', source.branch, 'target', 'rev2',
                              'rev1')
-        self.run_bzr('merge -d target directive')
+        out, err = self.run_bzr('merge -d target directive')
         self.failIfExists('target/a')
         self.failUnlessExists('target/b')
+        self.assertContainsRe(err, 'Performing cherrypick')
 
     def write_directive(self, filename, source, target, revision_id,
                         base_revision_id=None, mangle_patch=False):

